<%--------------------------------

			Content

----------%><%

	var	getFolderThumb = function(ao) {
				var vars = ao.getVars(),
					s;

				// Iconpath => SVG, folder thumb path
				if (s = vars.get('iconPath')) {
					s = s.replace('folder.png', 'folder.svg');
					return s.replace(/^\.\.\//, '');
				} else {
					return createFolderThumb(ao, folderThumbSize, true);
				}
			},
			
		getNewImagesContent = function(ao) {
				var vars = ao.getVars(),
					t = vars.get('fileTitle'),
					d;
				
				d = {
						fn:				'collectByDate',
						start:			today - (vars.get('newImagesDays') || 30),
						depth:			vars.get('newImagesDepth') || 'tree',
						sortBy:			vars.get('newImagesSort') || 'date',
						reference:		vars.get('newImagesSource') || 'dateTaken',
						reverse:		vars.get('newImagesReverse') || false,
						linkMore:		vars.get('closeupPath')
					};
				
				return (t? ('<h2>' + t + '</h2>') : '') + 
					'<div class="new-images single-row" data-jalbum-query=\'' + JSON.stringify(d) + '\'></div>';
			},
			
		getPageIcon = function(hook) {
				switch(hook) {
					case 'contents-page':
					case 'sitemap-page':
						return 'site';
					case 'contact-page':
						return 'email';
					case 'about-page':
						return 'user';
					case 'newimages-page':
						return 'new';
					case 'calendar-page':
						return 'calendar';
					default:
						return 'text-document';
				}
			},
			
		getPageThumbnail = function(ao) {
				var vars = ao.getVars(),
					s
					c;
					
				s = '<h3><a class="icon-' + getPageIcon(vars.get('pageHook')) + '" href="' + vars.get('closeupPath') + '"> ' + vars.get('title') + '</a></h3>';
				
				if (showPageExcerpt) {
					c = vars.get('aboutText') || vars.get('comment');
					
					if (c) {
						s += '<div class="caption">' + shorten(c.split('<!--more-->')[0]) + '</div>';
					}
				}
				
				return '<div class="card ' + captionPlacement + '">' + s + '</div>';
			};
		
	/******************************************************************
	 *
	 *						Main Content
	 *
	 ******************************************************************/
	
	for each (section in sectionsOrder.split('\t')) {
		
		switch (section) {
			
			case 'folders':
				
				var folders = getChildrenOfType(currentFolder, 'folder' + (hideWeblocations? '' : ',webLocation'));
				
				if (folders.length) {
					
					var vars,
						c,
						cp,
						ip,
						tp,
						ftw = folderThumbDims.split('x')[0],
						fth = folderThumbDims.split('x')[1],
						icon,
						alt,
						ask,
						wl;
					
					out.print('\t\t\t\t\t\t<section class="folder-cont"><div class="cont folders">');
						
					for (var i = 0; i < folders.length; i++) {
						
						vars = folders[i].getVars();
						c = vars.get('thumbCaption');
						cp = getExternalLink(vars) || vars.get('closeupPath');
						ip = vars.get('iconPath');
						tp = ip? (resPath + '/' + defaultFolderIconName) : vars.get('folderThumbPath');
						alt = addAltTags? stripHTML(vars.get('title') + ' ' + shorten(vars.get('comment'), 120, true)).trim() : '';
						ask = vars.get('askPermission');
						ask = (ask !== null)? (' data-ask-permission=\'' + ask.replace(/'/g, '&apos;') + '\'') : '';		//'
						wl = folders[i].getCategory() === Category.webLocation;
						if (!fixedShapeFolderThumbs) {
							// Variable folder thumb dimensions
							ftw = vars.get('folderThumbWidth');
							fth = vars.get('folderThumbHeight');
						}
						
						if (showFolderImageCount) {
							c += vars.get('counts');
						}
						
						// Thumbnail
						
						out.print('<div class="' + 
									[	'card',
										'folder',
										folderCaptionPlacement,
										(i >= preloadThumbs)? 'lazyload' : 'preload',
										(i < enhanceFolderCnt)? 'enhance' : '',
										wl? 'webloc' : ''
									].filter(Boolean).join(' ') +  
								'">');
						
						out.print('<a href="' + cp + '" class="thumb' + (ip? ' icon' : '') + '"' + ask + 
								// Open in new tab?
								((wl && webLocationOpenNew)? ' target="_blank"' : '') + 
								// Passing along thumbPath and alt for lazy loaded folders
								((i >= preloadThumbs)?
									(' data-src="' + tp + '"' + (alt? (' data-alt="' + alt + '"') : '') + 
										' data-width="' + ftw + '" data-height="' + fth + '">'
									)
									: 
									('><img src="' + tp + '"' + (alt? (' alt="' + alt + '"') : '') + 
										' width="' + ftw + '" height="' + fth + '">'
									)
								) +
							'</a>');
						
						if (i < enhanceFolderCnt) {
							
							// Mosaic
							
							var imgs = getRandomChildren(folders[i], 3, 'image,video,folder,webLocation', true),
								tp,
								ic,
								cat;
							
							out.print('<div class="mosaic">');
							
							if (imgs.length) {
								for (var j = 0, l = imgs.length; j < l; j++) {
									cat = imgs[j].getCategory();
									
									if (cat === Category.folder && imgs[i].getVars().get('iconPath')) {
										// No folder thumbnail
										tp = resPath + '/' + defaultFolderIconName;
										ic = 'icon ';
									} else {
										tp = encodeURIComponent(folders[i].getWebName()) + '/' + imgs[j].getVars().get('thumbPath');
										ic = '';
									}
									
									out.print('<a href="' + 
											((cat === Category.folder || j === l - 1)? cp : (cp + '#img=' + imgs[j].getWebName())) + 
											'"' + ask + ' class="' + ic + ((i >= preloadThumbs)? 'lazyload" data-src="' : 'preload"><img src="') + tp + '">' + 
											((j === l - 1)? '<span>+</span>' : '') + 
										'</a>');
									
								}
							}
							
							out.print('</div>');
						}
						
						if (c) {
							
							// Caption
							
							out.print('<div class="caption">' + c.replace(/(<h\d>)/, '$1<a href="' + cp + '"' + ask + '>').replace(/(<\/h\d>)/, '</a>$1') + '</div>');
						}
						
						out.print('</div>');
					}
					
					out.println('</div></section>');
				}
				
				break;
				
			case 'pages':
				
				if (showPages !== 'none') {
					var pages = getChildrenOfType(currentFolder, 'webPage'),
						s;
					
					if (pages.length) {
						// Creating pages section
						out.println('\t\t\t\t\t\t<section class="pages-cont">');
						
						if (showPages === 'embed' || showPages === 'embedCustom') {
							
							for (var i = 0, nm; i < pages.length; i++) {
								
								if (!pages[i].isHidden() && (showPages === 'embed' || !isPredefinedPage(pages[i]))) {
									//print(pages[i].getName() + ' is ' + (typeof pages[i]));
									//nm = pages[i].getVars().get('pageHook');
									nm = getOriginalPageName(pages[i], 'user');
									//print(pages[i].getName() + ' is ' + (typeof pages[i]) + ' hook: "' + nm + '"');
									s = (nm === 'newimages')? 
										getNewImagesContent(pages[i])
										:
										getCustomPageContent(pages[i]);
									
									if (s) {
										out.println('\t\t\t\t\t\t\t<div class="custom ' + nm + '-page">');
										out.println('\t\t\t\t\t\t\t\t<div class="cont page-wrap">\n' + s  + '\n\t\t\t\t\t\t\t\t</div>');
										out.println('\t\t\t\t\t\t\t</div>');
									}
								}
							}
							
							if (showPages === 'embedCustom') {
								s = '';
								
								for (var i = 0; i < pages.length; i++) {
									if (!pages[i].isHidden() && isPredefinedPage(pages[i])) {
										s += getPageThumbnail(pages[i]);
									}
								}
								
								if (s) {
									out.println('<div class="cont pages">' + s + '</div>');
								}
							}
							
						} else {
							s = '';
							
							for (var i = 0; i < pages.length; i++) {
								if (!pages[i].isHidden()) {
									s += getPageThumbnail(pages[i]);
								}
							}
							
							if (s) {
								out.println('<div class="cont pages">' + s + '</div>');
							}
						}
						
						out.println('\t\t\t\t\t\t</section>');
					}
					
				}
				
				break;
				
			case 'images':
				
				var images = getChildrenOfType(currentFolder, 'image,audio,video,other');
				
				if (images.length) {
					
					var vars,
						cat,
						alt,
						c,
						tw,
						th,
						ar,
						tp,
						icon,
						horizontal = thumbLayout === 'horizontal',
						sb = new StringBuffer();
						
					sb.append('\t\t\t\t\t\t<section class="thumb-cont base-overlay"><div class="' + 
							[ 	'cont',
								'thumbnails',
								thumbLayout,
								'caption-' + captionPlacement,
								(captionShowOnHover && captionPlacement !== 'below')? 'hover' : '',
								markActualImage? 'mark-active' : '',
								thumbGrayscaleEffect? 'grayscale' : '',
								(images.length > 2)? 'wrap' : ''
							].filter(Boolean).join(' ') +
						'">\n');
					
					for (var i = 0, j = 0; i < images.length; i++) {
						
						if (j >= preloadThumbs) {
							break;
						}
						
						vars = images[i].getVars();
						
						if (vars.get('sliderImage')) {
							continue;
						}
						
						cat = images[i].category;
						alt = addAltTags? (' alt="' + stripHTML(vars.get('title') + ' ' + vars.get('commentShort')).trim() + '"') : '';
						c = vars.get('thumbCaption');
						tw = vars.get('thumbWidth');
						th = vars.get('thumbHeight');
						ar = tw / th;
						tp = vars.get('thumbPath');
						icon = vars.get('iconPath');
						
						sb.append('<div class="' +
									[
										'card',
										'preload',
										cat,
										c? 'hascaption' : '',
										((tw < maxThumbWidth && th < maxThumbHeight)? 'tiny' : ''),
										icon? 'icon' : '',
										(ar >= 1.25)? 'landscape' : ((ar <= 0.8)? 'portrait' : 'square')
									].filter(Boolean).join(' ') +
								'"' +
									(horizontal? (' style="flex-basis:' + Math.round(vars.get('thumbWidth') * .9) + 'px;"') : '') + 
								'>' + 
								'<a class="thumb' +
									(((tw < maxThumbWidth) && (th < maxThumbHeight))? ' tiny' : '') +
									'" href="' + vars.get('imagePath') + '">' +
									'<img src="' + tp + '"' + alt + 
										(!icon? (' width="' + tw + '" height="' + th + '"') : '') +
										alt +
									'>' +
								'</a>' + 
								(c? ('<div class="caption">' + c + '</div>') : '') +
							'</div>\n');
						
						j++;
					}
					
					if (j) {
						sb.append('</div></section>');
						out.println(sb.toString());
					}
				}
				
				break;
		
			case 'map':
				
				if (mapInSections && !mapInSidebar && (typeof locationCount !== UNDEF) && locationCount) {
					out.println('\t\t\t\t\t\t<section class="map-cont"><div class="cont">' +
							(indexMapLabel? ('<h4 class="icon-location"> ' + indexMapLabel + '</h4>') : '') +
							'<div class="map-root" data-map-root></div>' +
						'</div></section>');
				}
				
				break;
			/*
			case 'shoppingCart':
				
				if (shopInSections && !shopInSidebar && (!showShopOnImagePagesOnly || (typeof shopCount !== 'undefined') && shopCount)) {
					
					out.println('\t\t\t\t\t\t<section class="row shop-cont">' +
						'<div class="columns box" id="shop-box">' +
							(shopLabel? ('<h4 class="icon-shopping-cart"> ' + shopLabel + '</h4>') : '') +
							'<div class="select-box"> ' + getText('select') + 
								'<a class="icon-ok select-all"> ' + getText('all') + '</a>' +
								'<a class="icon-close select-none"> ' + getText('none') + '</a>' +
							'</div>' +
							'<p><a class="icon-filter small button keep-selected"> ' + getText('keepOnlySelected') + '</a></p>' +
							'<div id="shop-root"></div>' +
						'</section>');
				}
				
				break;
			*/
			case 'neighboringFolders':
					
				if (level && linkNeighboringFolders) {
				
					if ((typeof previousFolderPath !== UNDEF) && previousFolderPath || 
						(typeof nextFolderPath !== UNDEF) && nextFolderPath) {
						
						out.print('\t\t\t\t\t\t<section class="prev-next-links"><div class="cont">');
						
						if (previousFolderPath) {
							out.print('<div class="previous-link">' + 
									'<a rel="prev" href="' + previousFolderPath + indexName + '"' +
										((typeof previousFolderAsk !== UNDEF)? (' data-ask-permission="' + previousFolderAsk + '"') : '') +
									'>' +
										((neighboringFolderBgImage && previousFolderThumbPath)? 
											('<span class="thumb" style="background-image:url(' + previousFolderThumbPath + ')">&nbsp;</span>') 
											: 
											'<span class="arrow icon-arrow-left">&nbsp;</span>'
										) +
										//'<span class="icon-caret-left"></span>' +
										'<span class="caption">' + previousFolderTitle + '</span>' +
									'</a>' +
								'</div>');
						}
						
						if (nextFolderPath) {
							out.print('<div class="next-link">' + 
									'<a rel="next" href="' + nextFolderPath + indexName + '"' + 
										((typeof nextFolderAsk !== UNDEF)? (' data-ask-permission="' + nextFolderAsk + '"') : '') +
									'>' +
										'<span class="caption">' + nextFolderTitle + ' </span>' +
										//'<span class="icon-caret-right"></span>' +
										((neighboringFolderBgImage && nextFolderThumbPath)? 
											('<span class="thumb" style="background-image:url(' + nextFolderThumbPath + ')">&nbsp;</span>') 
											: 
											'<span class="arrow icon-arrow-right">&nbsp;</span>'
										) +
									'</a>' +
								'</div>');
						}
						
						out.println('</div></section>');
					}
				}
				
				break;
				
			case 'comments':
				
				if (_useFacebookCommenting || _useDisqusCommenting) {
					
					out.println('\t\t\t\t\t\t<section class="commenting-cont"><div class="cont">' +
							(_useFacebookCommenting? ('<div class="fb-comments" id="fb-comments" data-num-posts="' + facebookCommentingPosts + '" data-width="100%" data-colorscheme="' + commentingTheme + '"' + (pageUrl? ' (data-href="' + pageUrl + '")' : '') + '></div>') : '') +
							(_useDisqusCommenting? '<div class="disqus-comments" id="disqus-comments"><div id="disqus_thread"></div></div>' : '') +
						'</div></section>');
				}
				
				break;
				
			case 'customContent':
				
				if (customSectionHook && (!level || !customSectionTopLevelOnly)) {
					out.println('\t\t\t\t\t\t<section class="custom-content"><div class="cont">' + 
							getProcessed(customSectionHook) + 
						'</div></section>');
				}
				
				break;
		}
	}
%>