/*
 *	init.js - initializing the skin, skin-specific utilities
 *	Author: Laza
 */
var JAFilter = Java.type("se.datadosen.jalbum.JAFilter"),
	FixedShapeFilter = Java.type("FixedShapeFilter");
	
	// Undefined
	UNDEF = 'undefined';

 	// URL-encoding should be always on
	engine.setUrlEncode(true);
	
	// Icon
	icon_menu =	'<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"><path d="M22,3.5V5H2V3.5ZM2,13H22V11.5H2Zm0,8H22V19.5H2Z" fill="#eee" fill-rule="evenodd"/></svg>';
	icon_home =	'<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"><path d="M18.5,21H5.5V13h-4L12,2.5,22.5,13h-4ZM17,19.5v-8h1.88L12,4.62,5.12,11.5H7v8Z" fill="#eee"/></svg>';
	icon_up = '<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"><path d="M14.75,19.5A3.75,3.75,0,0,1,11,15.75V6.37l5.12,5.12,1.06-1.06L10.25,3.5,3.32,10.43l1.06,1.06L9.5,6.37v9.38A5.26,5.26,0,0,0,14.75,21H22V19.5Z" fill="#eee"/></svg>';
	icon_prev =	'<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"><polygon points="23 11.25 4.87 11.25 12.93 3.19 11.87 2.13 2 12 11.87 21.87 12.93 20.81 4.87 12.75 23 12.75 23 11.25" fill="#eee"/></svg>';
	icon_next =	'<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"><polygon points="2 11.25 20.13 11.25 12.07 3.19 13.13 2.13 23 12 13.13 21.87 12.07 20.81 20.13 12.75 2 12.75 2 11.25" fill="#eee"/></svg>';
	icon_first = '<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"><polygon points="23 11.25 9.87 11.25 15.93 5.19 14.87 4.13 7 12 14.87 19.87 15.93 18.81 9.87 12.75 23 12.75 23 11.25" fill="#eee"/><rect x="3" y="3" width="1.5" height="18" fill="#eee"/></svg>';
	icon_last =	'<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"><polygon points="1 11.25 14.13 11.25 8.07 5.19 9.13 4.13 17 12 9.13 19.87 8.07 18.81 14.13 12.75 1 12.75 1 11.25" fill="#eee"/><rect x="19.5" y="3" width="1.5" height="18" transform="translate(40.5 24) rotate(-180)" fill="#eee"/></svg>';
	
	// Has subfolders or a simple album
	albumHasFolders = JAlbumUtilities.countCategories(rootFolder, false).getCount(Category.folder) > 0;
		
	// Create a stripped album description for use in a meta tag
	strippedAlbumDescription = stripHTML(albumDescription);
	
	// Making folder thumbs fixed shape for "tree" and "separate" placements
	if (fixedShapeThumbs || folderPlacement.equals("tree") || folderPlacement.equals("separate")) {
		engine.addFilter(new FixedShapeFilter(), JAFilter.FOLDERS_PRESCALE_STAGE);
	}
		
	processFile('photoswipe-init.js', 'res/photoswipe-init.js');
	processFile('justify.js', 'res/justify.js');	