	
	// Justify rows function
	let thumbDims = [ ${maxThumbWidth}, ${maxThumbHeight} ],
		thumbGap = ${thumbSpacing},
		thumbPad = ${borderPadding},
		borderWidth = ${borderWidth},
		xWidth = 2 * (thumbGap + thumbPad + borderWidth),
		justifyTimeout = null,
		
		justifyRow = function(cards, f) {
			f = Math.min(f * .999, 1.6);
			
			let h = Math.floor(thumbDims[1] * f);
			
			cards.forEach(function(card) {
				card.style.width = (parseInt(card.getAttribute('data-width')) * (f || 1)) + 2 * (thumbPad + borderWidth) + 'px';
				let el = card.querySelector('a');
				if (el) {
					el.style.height = h + 'px';
				}
				el = card.querySelector('.caption');
				if (el) {
					el.style.maxWidth = 'none';
				}
			});
		},
		
		clearDims = function(cards) {
			cards.forEach(function(card) {
				card.style.width = 'auto';	//parseInt(card.getAttribute('data-width')) + 'px';
				let el = card.querySelector('a');
				if (el) {
					el.style.height = thumbDims[1] + 'px';
				}
			});
		},
	
		justifyRows = function() {
			clearTimeout(justifyTimeout);
			
			let thumbs = document.querySelector('.thumbnails');
			
			if (!thumbs) {
				return;
			}
			
			let	cs = getComputedStyle(thumbs),
				cw = thumbs.clientWidth - parseFloat(cs.paddingLeft) - parseFloat(cs.paddingRight);
				
			if (thumbs.getAttribute('data-fixedfor') === cw) {
				return;
			}
			
			let	cards = Array.from(thumbs.children),
				i = 0, 
				rw = 0,
				w;
			
			while (cards.length && i < cards.length) {
				w = parseInt(cards[i].getAttribute('data-width')) + xWidth;
				if ((rw + w) >= cw) {
					if (rw + (w / 2) >= cw) {
						justifyRow(cards.slice(0, i), (cw - i * xWidth) / (rw - i * xWidth));
						cards = cards.slice(i);
					} else {
						justifyRow(cards.slice(0, i + 1), (cw - (i + 1) * xWidth) / (rw + w - (i + 1) * xWidth));
						cards = cards.slice(i + 1);
					}
					i = 0;
					rw = 0;
				} else {
					i++;
					rw += w ;
				}
			}
			
			if (cards.length && (cw / rw < 1.1)) {
				// Last row; justify only if close to fill
				justifyRow(cards, Math.min(1, cw / rw));
			} else {
				clearDims(cards);
			}
			
			thumbs.setAttribute('data-fixedfor', cw);
		};
	
	window.addEventListener('load', function() {
		if (document.querySelector('.thumbnails')) {
			justifyTimeout = setTimeout(justifyRows, 100);
			window.addEventListener('resize', function(e) {
				clearTimeout(justifyTimeout);
				justifyTimeout = setTimeout(justifyRows, 500);
				return true;
			});
		}
	});