;(function($, $window) {
	'use strict';
				
	/* 
		sticky.js - renders 'sticky' class to off-screen layers
	*/

	$.fn.sticky = function(options) {
		
			options = $.extend({
							stickyClass:		'sticky',					// Sticky class
							stickToEdge:		'st-stick',					// The first/last element that need to be stick to edge class
							topmostClass:		'st-topmost',				// First element but not stick to window top
							bottommostClass:	'st-bottommost',			// First element but not stick to window top
							topClass:			'st-top',					// Top class
							bottomClass:		'st-bottom',				// Bottom class
							placeholderClass:	'st-placeholder',			// Placeholder class
							watch:				'.thumbnails',				// Only if this section is on screen
							placeBelow:			'.top-bar.sticky'			// Extra top position to add above
						}, options);
			
			var ns = 'lst_' + Math.floor(Math.random() * 10000),
				st = new Array(),
				last = -999,
				
				// Getting panel's top/bottom position
				/*
				getPos = function(pos) {
						var h = 0,
							el = $('.' + options.stickyClass + '.' + pos);
						
						el.each(function() {
								h += $(this).outerHeight();
							});
						
						return h;
					},
				*/
				
				// Make panel static
				
				makeStatic = function(i) {
						var el = $('[data-sticky-rel=' + st[i].id + ']'),
							p = $('#' + st[i].id);
							
						if (el.length && el.hasClass(options.stickyClass)) {
							// Hiding placeholder
							p.height(0);
							// On screen
							el.removeClass(options.stickyClass + ' ' + options.topClass + ' ' + options.bottomClass);
						}
					},
					
				// Make all panels static
				
				makeAllStatic = function() {
					
						for (var i = 0; i < st.length; i++) {
							makeStatic(i);
						}
					},
					
				// Checking all elements
				
				checkPos = function() {
						var wt = $window.scrollTop(),
							wh = $window.outerHeight(),
							watch = $(options.watch + ':visible'),
							offsTop,
							offsBtm,
							topmost,
							bottommost,
							wpt;
						
						if (Math.abs(wt - last) <= 2) {
							// Already checked
							return;
						}
						
						if (!watch.length || (wpt = watch.position().top) > wt + wh - 100 || (wpt + watch.outerHeight(true) <= wt + 100)) {
							// No watch element on screen
							makeAllStatic();
							
						} else {
							
							offsTop = $(options.placeBelow + ':visible').height() || 0;
							topmost = true;
							
							$('.' + options.topClass + '.' + options.stickyClass + ':visible').each(function() {
									offsTop += $(this).outerHeight();
									topmost = false;
								});
							
							offsBtm = 0;
							bottommost = true;
							
							$('.' + options.bottomClass + '.' + options.stickyClass + ':visible').each(function() {
									offsBtm += $(this).outerHeight();
									bottommost = false;
								});
							
							// Watch element is on screen
							for (var i = 0, el, p, pt, ph; i < st.length; i++) { 
								el = $('[data-sticky-rel=' + st[i].id + ']');
								p = $('#' + st[i].id);
								
								if (el.length && p.length) {
									// Panel's top position
									pt = p.position().top;
								
									if ((pt + st[i].height - st[i].marginBottom) > (wt + wh - offsBtm) || 
										(pt + st[i].marginBottom) < (wt + offsTop)) {
										// Place as sticky
										if (!el.hasClass(options.stickyClass)) {
											// Make the placeholder same height
											p.height(st[i].height);
											el.addClass(options.stickyClass);
											
											if ((pt + st[i].marginBottom) < (wt + offsTop)) {
												// Above
												//pt = getPos(options.topClass);
												
												if (offsTop) {
													// Offsetting already existing stickies
													el.removeClass(options.stickToEdge).css('top', offsTop);
												} else {
													el.addClass(options.stickToEdge);
												}
												
												if (topmost) {
													el.addClass(options.topmostClass);
												}
												
												el.addClass(options.topClass).removeClass(options.bottomClass);
												
											} else {
												// Below
												//pt = getPos(options.bottomClass);
												
												if (offsBtm) {
													el.removeClass(options.stickToEdge).css('bottom', offsBtm);
												} else {
													el.addClass(options.stickToEdge);
												}
												
												if (bottommost) {
													el.addClass(options.bottommostClass);
												}
												
												el.addClass(options.bottomClass).removeClass(options.topClass);
											}
										}
										
									} else {
										// Place as static
										makeStatic(i);
									}
								}
							}
						}
						
						return true;
					};
					
			// Preprocessing elements
			this.each(function(i) {
					var el = $(this),
						cont = el.children().first(),
						id = ns + '_' + i;
					
					el.before($('<div>', {
							id:				id,
							'class': 		options.placeholderClass
						}));
					
					el.attr('data-sticky-rel', id);
					
					st[i] = {
							id:				id,
							height:			el.outerHeight(true),
							marginTop:		(parseInt(cont.css('margin-top')) || 0) + (parseInt(el.css('padding-top')) || 0),
							marginBottom:	(parseInt(cont.css('margin-bottom')) || 0) + (parseInt(el.css('padding-top')) || 0)
						}
				});
			
			$(this).on('stickyRefresh', function() {
					last = -999;
					checkPos();
				});
			
			// Scroll event listener
			$window.on('scroll.' + ns + ' resize.' + ns, checkPos);
			
			// Initial check
			checkPos();
			
			return this;
		};
	
}(jQuery, jQuery(window)));