/* JAlbum tool that caches image ordering by setting all sub folders to "Custom" ordering
 * thereby speeding up huge albums that have previously been ordered according to Camera settings
 */

Work.on(TreeCollection.of(selectedObjects).stream().filter(ao -> ao.folder))
.titled("Cache image ordering")
.inform("This script speeds up processing of huge albums that are ordered by camera date\nby using custom ordering for all selected sub folders")
.forEach(folder) -> {
	folder.setChildren(folder.getChildren());
	folder.setOrdering(AlbumObject.Ordering.custom);
}
.showResult();
